﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media.Media3D;

namespace Tonwicht_Management.Classes
{
    public class Article
    {
        private int id;
        private string name;
        private int WaregroupID;
        private double size;
        private double weight;
        private double price;
        private int stock;
        private DateTime created;
        private DateTime changed;
        public string Name => this.name;
        public string WaregroupName
        {
            get
            {
                foreach (Waregroup wg in Cache.Waregroups)
                {
                    if (wg.Get_ID() == this.WaregroupID) return wg.GetName();
                }

                return "not found";
            }
        }
        public double Size => this.size;
        public double Weight => this.weight;
        public double Price => this.price;
        public string LocalImagePathFront
        {
            get
            {
                foreach (string fileName in Cache.ArticleImages)
                {
                    if(fileName.StartsWith(this.Get_ID() + "_1"))
                        return Cache.ArticleImages_BaseURL + fileName;
                }

                return "";                
            }
        }

        public string LocalImagePathBack
        {
            get
            {
                foreach (string fileName in Cache.ArticleImages)
                {
                    if (fileName.StartsWith(this.Get_ID() + "_2"))
                        return Cache.ArticleImages_BaseURL + fileName;
                }

                return "";
            }
        }

        public void Set_ID(int id) => this.id = id;
        public void Set_Name(string name) => this.name = name;
        public void Set_WaregroupID(int id) => this.WaregroupID = id;
        public void Set_Size(double size) => this.size = size;
        public void Set_Weight(double weight) => this.weight = weight;
        public void Set_Price(double price) => this.price = price;
        public void Set_Stock(int stock) => this.stock = stock;
        public void Set_Created(DateTime created) => this.created = created;
        public void Set_Changed(DateTime changed) => this.changed = changed;

        public int Get_ID() => this.id;
        public string Get_Name() => this.name;
        public int Get_WaregroupID() => this.WaregroupID;
        public double Get_Size() => this.size;
        public double Get_Weight() => this.weight;
        public int Get_Stock() => this.stock;
        public DateTime Get_Created() => this.created;
        public DateTime Get_Changed() => this.changed;
    }
}
