﻿using Renci.SshNet;
using Renci.SshNet.Common;
using Renci.SshNet.Sftp;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;

namespace Tonwicht_Management.Connectors
{
    internal class SFTP_Connector
    {
        private SftpClient _client;
        private readonly string basePath = "/var/www/html/cdn.tonwicht.de/";

        public SFTP_Connector()
        {
            this._client = new("cdn.tonwicht.de", 22, "tonwicht-upload", "3R88dYfUwjudx5KRbE*9");
            this._client.Connect();
        }

        ~SFTP_Connector() {
            _client.Dispose();
        }

        public List<SftpFile> Get_ArticleImages()
        {
            List<SftpFile> files = new List<SftpFile>();

            foreach (SftpFile sftpFile in this._client.ListDirectory(this.basePath + "images/articles/"))
            {
                if (sftpFile != null && sftpFile.Name != "." && sftpFile.Name != "..")
                {
                    files.Add(sftpFile);
                }
            }

            return files;
        }

        /// <summary>
        /// Downloads a file using sftp to local drive
        /// </summary>
        /// <param name="source">path on server to download</param>
        /// <param name="destination">path to where the file is saved</param>
        public void DownloadFile(string source, string destination)
        {
            using (Stream fileStream = File.Create(destination))
            {
                this._client.DownloadFile(source, fileStream);
            }
        }

        public void UploadFile(string source, string destination)
        {
            using (Stream fileStream = File.OpenRead(source))
            {
                this._client.UploadFile(fileStream, basePath + destination);
            }
        }

        public void DeleteFile(string file)
        {
            this._client.DeleteFile(this.basePath + file);
        }
    }
}
